Subject: Re: [lojban] Lisp (was: Programming Languages for Lojban)

From: Björn Gohla <[email-masked]>
Date: Wed, 13 Mar 2002 12:50:42 +0100

On Wednesday 13 March 2002 11:51, John Cowan wrote:
> Jim Carter scripsit:
> > I don't know all that much about Lisp, but my impression is that it is
> > much more a procedural language. And if its pattern recognition code were
> > written in a highly procedural fashion, the result would be achingly
> > slow.
>
> Lisp need not be slow; that's a mental hangover from the days when
> all Lisp systems were interpreters. Already back in the 70s Lisp
> numerical code ran as fast as Fortran.
>
> Lisp (especially its Scheme dialect) is fundamentally an Algol-style
> language, but with cheap object creation, garbage collection, local
> variables and function pointers (the two together are much sweeter
> than just local variables as in Pascal or just function pointers as
> in C), and first-class continuations (which provides for easy
> non-local control flow). It is greatly superior, as was said of
> Algol 60, to almost all of its successors.

not to forget macros, which i expect to be quite powerful in what we want to 
do. the known c preprocessor macros are but a faint shadow of scheme macros, 
wich are really in effect extensions to the interpreter (or the compiler).

i remember reading a scholarly comparison of c(++), java and lisp. compiled 
lisp code was comparable to c++ but obviously not as fast as c code. lisp 
showed the up as the language with the best average development time for a 
number of programming exercises. although that leaves the question wether 
good programmers choose lisp (or scheme) or using those languages makes you 
one good programmer ;) . i will port the url.
- -- 
panic ("No CPUs found. System halted.\n");
2.4.3 linux/arch/parisc/kernel/setup.c
pub 1024D/834F4976 2001-01-07 Björn Gohla (Wissenschaftler, Weltbürger) 
<[email-masked]>
Key fingerprint = 9FF4 FEDA CCDF DA0E 14D5 8129 6C14 3C39 834F 4976
sub 1024g/29571FE2 2001-01-07